import EventTarget from './EventTarget';
import { IHistorified } from './History';
export interface IPaintTool {
    enable: () => void;
    disable: () => void;
    enabled: boolean;
}
export interface IPaintTools {
    [key: string]: IPaintTool;
}
export interface IBoardScale {
    x: number;
    y: number;
}
export interface IBoardOperation {
    (context: CanvasRenderingContext2D): void;
}
export interface IBoardOptions {
    color?: string;
    scale?: IBoardScale;
    activeToolName?: string;
    statics?: Array<Array<IBoardOperation>>;
    records?: Array<Array<IBoardOperation>>;
    index?: number;
}
declare class Board extends EventTarget {
    context: IHistorified<CanvasRenderingContext2D>;
    container: HTMLDivElement;
    background: CanvasRenderingContext2D;
    options: IBoardOptions;
    tools: IPaintTools;
    activeToolName: string;
    color: string;
    size: number;
    scale: IBoardScale;
    statics: Array<Array<IBoardOperation>>;
    static defaultOptions: IBoardOptions;
    static fromBoard(board: Board): Board;
    constructor(options?: IBoardOptions);
    mount(parent: HTMLElement): void;
    use(activeToolName: string): void;
    setColor(color: string): void;
    setSize(size: number): void;
    setScale(scale: any): void;
    setWidth(width: number): void;
    setHeight(height: number): void;
    draw(fromIndex?: number, toIndex?: number): void;
    drawDynamics(fromIndex?: number, toIndex?: number): void;
    drawStatics(): void;
    clear(): void;
    export(mimeType?: string): string;
}
export default Board;
