import EventTarget from './EventTarget';
export interface HistoryOperation<TTarget> {
    (context: TTarget): void;
}
export default class History<TTarget> extends EventTarget {
    records: Array<Array<HistoryOperation<TTarget>>>;
    index: number;
    readonly operations: HistoryOperation<TTarget>[];
    constructor(context: TTarget, records?: Array<Array<HistoryOperation<TTarget>>>, index?: number);
    next(operations?: Array<HistoryOperation<TTarget>>): void;
    canUndo(): boolean;
    undo(): void;
    canRedo(): boolean;
    redo(): void;
}
export declare type IHistorified<TTarget> = TTarget & {
    original: TTarget;
    history: History<TTarget>;
};
export declare function historify<TTarget>(target: TTarget, records?: Array<Array<HistoryOperation<TTarget>>>, index?: number): IHistorified<TTarget>;
